package be.iminds.ilabt.jfed.experiment.setup.config;

import com.fasterxml.jackson.annotation.*;

import javax.annotation.Nonnull;
import javax.annotation.Nullable;

@JsonInclude(JsonInclude.Include.NON_DEFAULT)
@JsonIgnoreProperties(value={"@context"})
public class AlreadyProvisionedRequestRSpec extends RequestRSpec {
    public AlreadyProvisionedRequestRSpec() {
        super(RequestRSpecSource.ALREADY_PROVISIONED,
                false,
                false);
    }

    @JsonCreator
    public AlreadyProvisionedRequestRSpec(@Nonnull @JsonProperty("source") RequestRSpecSource source,
                                          @Nullable @JsonProperty("autoAssignSpecificNodesUsingListResources") Boolean autoAssignSpecificNodesUsingListResources,
                                          @Nullable @JsonProperty("useNitosLease") Boolean useNitosLease) {
        super(source, autoAssignSpecificNodesUsingListResources, useNitosLease);
        assert source == RequestRSpecSource.ALREADY_PROVISIONED;
        assert this.getSource() == RequestRSpecSource.ALREADY_PROVISIONED;
    }

    @JsonIgnore
    public boolean isValid() {
        return true;
    }
}
